﻿using System.Linq;
using System.Collections.Generic;
using System.Reflection;
using RimWorld;
using Verse;
using Verse.AI;

namespace LT
{
    public class Building_DoorMat : Building
    {
        //Syrchalis' code is nice.
        static FieldInfo carriedFilthList = typeof(Pawn_FilthTracker).GetField("carriedFilth", BindingFlags.NonPublic | BindingFlags.Instance);

        public override void Tick()
        {
            base.Tick();
            // Execute only every 10 ticks
            if (! this.IsHashIntervalTick(10))
            {
                return;
            }
            foreach (var rect in this.OccupiedRect())
            {
                if (rect.Impassable(Map))
                {
                    continue;
                }
                
                var pawns = Map.thingGrid.ThingsAt(rect)
                    .Where(s => s.GetType() == typeof(Pawn))
                    .Cast<Pawn>();
                foreach (var pawn in pawns)
                {
                    
                    List<Filth> carriedFilth = (List<Filth>)carriedFilthList.GetValue(pawn.filth);
                    if (!carriedFilth.NullOrEmpty())
                    {
                            pawn?.filth.GetType().GetMethod("TryDropFilth", BindingFlags.Instance | BindingFlags.NonPublic)
                               .Invoke(pawn.filth, null);
                        carriedFilth.RemoveRange(0, carriedFilth.Count / 2); //Not as powerful as Syr's code
                    }

                }
            }
        }

        public override void DrawGUIOverlay()
        {
            //
        }
    }
}